Bug 59173 - New fields/changed defaults cause earlier test plans to be marked as changed
Summary: New fields/changed defaults cause earlier test plans to be marked as changed
Status: RESOLVED FIXED
Alias: None
Product: JMeter
Classification: Unclassified
Component: Main (show other bugs)
Version: Nightly (Please specify date)
Hardware: All All
: P2 normal (vote)
Target Milestone: ---
Assignee: JMeter issues mailing list
URL:
Keywords:
Depends on:
Blocks: 59241
  Show dependency tree
 
Reported: 2016-03-13 00:07 UTC by Sebb
Modified: 2016-03-27 19:39 UTC (History)
1 user (show)



Attachments
Test plan created in JMeter 2.13 (7.10 KB, text/plain)
2016-03-13 00:08 UTC, Sebb
Details
Test plan saved with JMeter trunk (7.46 KB, text/plain)
2016-03-13 00:10 UTC, Sebb
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Sebb 2016-03-13 00:07:31 UTC
Create a Test Plan with JMeter 2.13 containing:

Access Log Sampler
JMS Publisher
Regular Expression Extractor
Backend Listener

Open it in JMeter trunk version.

View one or more of the test elements - don't change anything - and then select the Test Plan.

Press Quit; it will prompt to save the changed Test Plan.

If you save the plan to a new file and compare the files, there are several differences.

There are two causes:
- new fields which have been added without defining default values
- existing fields which have new defaults

It's disconcerting to be warned that the test plan has changed when that is not the case. The issue will keep occurring until test plans using any of those elements have been updated. 

This bug means that test plans are not properly upwards-compatible.
Comment 1 Sebb 2016-03-13 00:08:47 UTC
Created attachment 33664 [details]
Test plan created in JMeter 2.13
Comment 2 Sebb 2016-03-13 00:10:30 UTC
Created attachment 33665 [details]
Test plan saved with JMeter trunk
Comment 3 Philippe Mouawad 2016-03-15 21:37:56 UTC
Author: pmouawad
Date: Tue Mar 15 21:37:38 2016
New Revision: 1735170

URL: http://svn.apache.org/viewvc?rev=1735170&view=rev
Log:
Bug 59173 - New fields/changed defaults cause earlier test plans to be marked as changed
Fix RegExtractor saving with 3.0
Bugzilla Id: 59173

Modified:
    jmeter/trunk/src/components/org/apache/jmeter/extractor/RegexExtractor.java
Comment 4 Philippe Mouawad 2016-03-15 22:15:47 UTC
1/ For AccessLogSample, new protocol field was introduced, it doesn't hurt me that JMeter asks user to save.
But if you see how to fix it, go ahead. 

2/ For Backend Listener, again a new parameter was introduced, I am not sure we can fix the saving so that this new fields is not appended.

3/ For JMS Publisher, I am not sure it can be properly fixed as in 2.13, we made a mistake in the way we managed JMS Priority and JMS Expiry default values. 
But if you see how to fix it, go ahead
Comment 5 Sebb 2016-03-19 12:18:45 UTC
URL: http://svn.apache.org/viewvc?rev=1735765&view=rev
Log:
New fields/changed defaults cause earlier test plans to be marked as changed
Fix AccessLogSampler; added TestBean support for not saving default values
Bugzilla Id: 59173

Modified:
    jmeter/trunk/src/core/org/apache/jmeter/testbeans/BeanInfoSupport.java
    jmeter/trunk/src/core/org/apache/jmeter/testbeans/gui/GenericTestBeanCustomizer.java
    jmeter/trunk/src/core/org/apache/jmeter/testbeans/gui/TestBeanGUI.java
    jmeter/trunk/src/protocol/http/org/apache/jmeter/protocol/http/sampler/AccessLogSamplerBeanInfo.java
Comment 6 Sebb 2016-03-19 14:27:43 UTC
URL: http://svn.apache.org/viewvc?rev=1735776&view=rev
Log:
New fields/changed defaults cause earlier test plans to be marked as changed
Fix PublisherSampler: convert default to empty string on output (as that is what the input methods do)
Bugzilla Id: 59173

Modified:
    jmeter/trunk/src/protocol/jms/org/apache/jmeter/protocol/jms/sampler/PublisherSampler.java
Comment 7 Sebb 2016-03-19 14:28:34 UTC
Note: this bug applies to nightlies after 2.13
Comment 8 Sebb 2016-03-22 00:55:24 UTC
URL: http://svn.apache.org/viewvc?rev=1736119&view=rev
Log:
New fields/changed defaults cause earlier test plans to be marked as changed
Fix BackendListener
Bugzilla Id: 59173

Modified:
    jmeter/trunk/src/components/org/apache/jmeter/visualizers/backend/BackendListener.java
Comment 9 Philippe Mouawad 2016-03-27 19:34:47 UTC
Date: Sun Mar 27 19:33:47 2016
New Revision: 1736811

URL: http://svn.apache.org/viewvc?rev=1736811&view=rev
Log:
Bug 59173 - New fields/changed defaults cause earlier test plans to be marked as changed
Bugzilla Id: 59173

Modified:
    jmeter/trunk/xdocs/changes.xml